﻿// 外貨レート表示ガジェット　1.0.0

//オプションのデフォルト値
options.putDefaultValue("Currency Pair","USD/JPY");

//オプションメニューアイテム追加イベントハンドラ設定(更新用)
plugin.onAddCustomMenuItems = AddCustomMenuItems;

//オプションダイアログ表示のイベントハンドラ設定(通貨ペア用)
plugin.onShowOptionsDlg = ShowOptionsDlg;
 
//1分前のBitRate
var BeExVal = 0;

//ガジェットが最小化状態かを示すフラグ
var bMinimized = false;

//XML HTTPオブジェクト予約
var xmlHttp = null;

//通貨ペア名
var Currency = null;


//ビューオープンイベントハンドラ
function view_onOpen()
{
  UpdateRate();

  //1分間隔で定期的にプログラムをコール
  setInterVal("UpdateRate()", 60000);

}

//レート更新
function UpdateRate() {

  //Infoseek ファイナンスurl
  var url = 'http://money.www.infoseek.co.jp/MnForex/';

  //フレーム表示を初期化
  lblExRate.innerText = "Updating...";
  lblExHiLo.innerText = "";

  Currency = options.getValue("Currency Pair");

  lblExName1.innerText = Currency.substring(0,3);
  lblExName2.innerText = Currency.substring(4,7);

  //XML HTTPオブジェクト生成とリクエスト送信
  xmlHttp = new XMLHttpRequest();
  xmlHttp.onreadystatechange = OnData;
  xmlHttp.open("GET", url, true);
  xmlHttp.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT");
  xmlHttp.send();
}

//XML読み込み処理
function OnData() {
  var exArray = new Array(6);	//Rateデータ格納
  var BeDayCol;			//前日比　色
  var st = 0;			//読出し開始位置
  var en = 0;			//読出し終了位置
  var i = 0;

  //リクエスト正常読み込み完了でデータ受信完了
  if(xmlHttp.readyState == 4) {
  　var strm = xmlHttp.responseText;

   if(strm != null && strm.length > 0){

　　　 //指定通貨ペア抽出
     st = strm.search(Currency);
   }else{
     st = -1;
   }

   if(st != -1){

　　　//0.Bid 1.Ask 2.前日比 3.始値 4.高値 5.安値 
    for(i = 0 ; i <= 5 ; i++){   
      st = strm.indexOf("<td>",st) + 4;
      en = strm.indexOf("</td>",st);
      exArray[i] = strm.substring(st,en);
    }

    //1分前とのRate比較
    if(BeExVal == exArray[0] || BeExVal == 0){
	Face.background = "#CECEC2";		//変化なし
    }else{
	if(BeExVal < exArray[0]){
	    Face.background = "#90D7FF";	//高く変化
	}else{
	    Face.background = "#FFA72B";	//低く変化
        }
    }
    BeExVal = exArray[0];

    //前日比判定
    BeDayCol = exArray[2].substring(14,20);

    if(BeDayCol == "cc0000"){			//前日より円安変化
	lblExName1.color = "#0000FF";
	lblExName2.color = "#FF0000";
    }else{
	if(BeDayCol == "008800"){		//前日より円高変化
	    lblExName1.color = "#FF0000";
	    lblExName2.color = "#0000FF";
	}else{					//前日と変わらず
	    lblExName1.color = "#222222";
	    lblExName2.color = "#222222";
        }
    }

   }else{
    //フレームにエラー表示
    lblExRate.innerText = "Error...";
    lblExHiLo.innerText = "";
   }
  }else{
   //フレームにリロード表示
   lblExRate.innerText = "Updating...";
   lblExHiLo.innerText = "";
  }

  //フレームにレートを表示
  if(exArray[0] != null){
    lblExRate.innerText = exArray[0] + "-" + exArray[1];
    lblExHiLo.innerText = "Hi=" + exArray[4] + " Lo=" + exArray[5];
 
 //最小化時にタイトルバーキャプションにレートを表示
  　　if (bMinimized == true){
    　　view.caption = Currency + " " + exArray[0];
    }else{
      view.caption = GADGET_NAME;
    }
  }
 
}

//ガジェットが最小化された時の処理
function view_onMinimize(){
  bMinimized = true;
  UpdateRate();
}

//ガジェットが最小化状態から復元された時の処理
function view_onRestore(){
  bMinimized = false;
  view.caption = GADGET_NAME;
}

//更新メニュー追加
function AddCustomMenuItems(menu)
{
  menu.AddItem(MENU_UPDATE, 0, UpdateRate);
}

//オプションダイアログ表示のイベントハンドラ
function ShowOptionsDlg(wnd){

  //通貨ペア
  var CurrencyList = new Array(
    "USD/JPY",
    "EUR/JPY",
    "EUR/USD",
    "GBP/JPY",
    "AUD/JPY",
    "CHF/JPY",
    "CAD/JPY",
    "NZD/JPY"
  );

  //通貨ペアコントロールの生成
  wnd.AddControl(gddWndCtrlClassLabel,0,"","Currency Pair: ",20,33,70,24);

  var PairDropList = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "PairDropList", CurrencyList, 100, 30, 160, 24);
  PairDropList.value = options.getValue("Currency Pair");

  //オプションダイアログ閉じるときのイベントハンドラの設定
  wnd.onClose = OptionsDlgClosed;
}

//オプションダイアログ閉じるときのイベントハンドラ
function OptionsDlgClosed(wnd,code){

  //OKボタンを押したときのオプション更新
  if (code == gddIdOK) {

    //通貨ペアを取得
    var CurrencyP = wnd.GetControl("PairDropList").value;

    //通貨ペア変更があったら更新処理
    if(options.getValue("Currency Pair") != CurrencyP){
      options.putValue("Currency Pair" , CurrencyP);

　　　　　//1分前のBitRateをリセット
      BeExVal = 0;
      UpdateRate();
    }
  }
}